<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>slugstring - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="HttpQuery.html">HttpQuery</a><ul class='methods'><li data-type='method' style='display: none;'><a href="HttpQuery.html#send">send</a></li></ul></li><li><a href="HttpQueryService.html">HttpQueryService</a></li><li><a href="PersistantData.html">PersistantData</a><ul class='methods'><li data-type='method' style='display: none;'><a href="PersistantData.html#loadJSON">loadJSON</a></li><li data-type='method' style='display: none;'><a href="PersistantData.html#saveJSON">saveJSON</a></li><li data-type='method' style='display: none;'><a href="PersistantData.html#list">list</a></li><li data-type='method' style='display: none;'><a href="PersistantData.html#getNewID">getNewID</a></li></ul></li><li><a href="PersistantDataService.html">PersistantDataService</a><ul class='methods'><li data-type='method' style='display: none;'><a href="PersistantDataService.html#~getQuery">getQuery</a></li><li data-type='method' style='display: none;'><a href="PersistantDataService.html#~getNewId">getNewId</a></li></ul></li><li><a href="RemanentForm.html">RemanentForm</a><ul class='methods'><li data-type='method' style='display: none;'><a href="RemanentForm.html#load">load</a></li></ul></li><li><a href="ServerEvent.html">ServerEvent</a><ul class='methods'><li data-type='method' style='display: none;'><a href="ServerEvent.html#onEvent">onEvent</a></li><li data-type='method' style='display: none;'><a href="ServerEvent.html#isPending">isPending</a></li><li data-type='method' style='display: none;'><a href="ServerEvent.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="ServerEvent.html#addClock">addClock</a></li></ul></li><li><a href="ServerEventService.html">ServerEventService</a><ul class='methods'><li data-type='method' style='display: none;'><a href="ServerEventService.html#~doQuery">doQuery</a></li><li data-type='method' style='display: none;'><a href="ServerEventService.html#add">add</a></li><li data-type='method' style='display: none;'><a href="ServerEventService.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="ServerEventService.html#addClock">addClock</a></li></ul></li><li><a href="StopService.html">StopService</a></li><li><a href="UploadService.html">UploadService</a></li><li><a href="WrapperCC.html">WrapperCC</a><ul class='methods'><li data-type='method' style='display: none;'><a href="WrapperCC.html#call">call</a></li></ul></li><li><a href="WrapperCCService.html">WrapperCCService</a></li><li><a href="cookies.html">cookies</a><ul class='methods'><li data-type='method' style='display: none;'><a href="cookies.html#.get">get</a></li><li data-type='method' style='display: none;'><a href="cookies.html#.set">set</a></li></ul></li><li><a href="slugstring.html">slugstring</a><ul class='methods'><li data-type='method' style='display: none;'><a href="slugstring.html#.fill">fill</a></li></ul></li></ul><h3>Global</h3><ul><li><a href="global.html#wrap">wrap</a></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">slugstring</h1>
    

    




<section>

<header>
    
        <h2>
        
            slugstring
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="slugstring"><span class="type-signature"></span>factory slugstring<span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Sets all strings of the page given a dictionary.</p>
<ul>
<li>
<p>In order to define a multi-language HTML page,</p>
<ul>
<li>all strings are defined in an external dictionary</li>
<li>and indexed by a slug in the HTML page.</li>
</ul>
</li>
<li>
<p>By multi-language we consider</p>
<ul>
<li>different country languages (e.g., Hindi or Thai) or</li>
<li>target adapted text (e.g. for kids or elder).</li>
</ul>
</li>
</ul>
<h1>Defining the slug -&gt; string mapping</h1>
<ul>
<li>The <em>external dictionary</em> is a Javascript file defining the <code>slug -&gt; string</code> mapping.
<ul>
<li>This file contains all the  strings of the web site:</li>
</ul>
</li>
</ul>
<pre class="prettyprint source"><code>const dictionary = {
  // Defines the &quot;$slug&quot; : &quot;$string&quot; mapping.
  &quot;page-title&quot; : &quot;Title of the page&quot;,
  ../..
};
</code></pre>
<p>This file is called <code>dictionary.js</code> in the sequel.</p>
<h1>Using the slug -&gt; string mechanism in a HTML page</h1>
<ul>
<li>In the page, each string is defined by its slug (notice the ``.´´ in the tag content to avoid empty tags), e.g.:</li>
</ul>
<pre class="prettyprint source"><code>   &lt;span data-slug='$slug'>.&lt;/span>
</code></pre>
<ul>
<li>
<p>This can be applied to the <code>&lt;span...</code>, <code>&lt;a...</code>, <code>&lt;h1...</code>, <code>&lt;h2...</code>, <code>&lt;h3...</code>, <code>&lt;h4...</code>, <code>&lt;span...</code>, <code>&lt;label...</code>, <code>&lt;input...</code>, <code>&lt;button...</code>, <code>&lt;option...</code>,<code>&lt;p...</code>,</p>
</li>
<li>
<p>The following construct, usually at the end of the HTML page, fills the strings:</p>
</li>
</ul>
<pre class="prettyprint source"><code>  &lt;!-- Loads the slugstring mechanism, &quot;.../&quot; is the file directory -->
  &lt;script src=&quot;https://line.gitlabpages.inria.fr/aide-group/slugstring/slugstring.js&quot;>&lt;/script>
  &lt;!-- Loads the slug -> string dictionary of this page, &quot;.../&quot; is the file directory -->
  &lt;script src=&quot;.../dictionnary.js&quot;>&lt;/script>
  &lt;!-- Fills all string, this is to be called AFTER the HTML tags definition -->
  &lt;script>slugstring.fill(dictionnary);&lt;/script>
</code></pre>
<p>We may also use the construct:</p>
<p><code>&lt;body onload=&quot;slugstring.fill(dictionary)&quot;&gt;</code></p>
<p>to fill the string immediately after the page has been loaded.</p>
<h2>Testing the mechanism</h2>
<ul>
<li>Opening the <a href="https://gitlab.inria.fr/line/aide-group/slugstring/-/blob/master/src/_test.html">_test.html</a> file allows to both run a test and have a complete example.</li>
</ul>
<h1>Managing several languages in the same page</h1>
<p>Considering several languages dictionaries assembled in a data structure of the form</p>
<pre class="prettyprint source"><code>const dictionaries = {
  // Defines the &quot;$lang&quot; : &quot;$dictionary&quot; mapping.
  &quot;fr.slang&quot; : fr_slang_dictionary,
  &quot;fr.fr&quot;    : fr_fr_dictionary,
  ../..
};
</code></pre>
<p>the <code>slugstring.fill(dictionaries[lang])</code> construct allows to parameterized the string setting.</p>
<p>For instance:</p>
<ol>
<li>The language is defined in the</li>
</ol>
<center><tt>&lt;html lang="fr.slang"></tt></center>
HTML document first line, thus 
<center><tt>lang = document.documentElement.lang</tt>.</center>
<ol start="2">
<li>The language can be given via the page URL query, e.g., something like</li>
</ol>
<center><tt>http://page-url?lang=fr.slang</tt>,</center>
thus can be retrieved using:
<center><tt>lang=new URLSearchParams(window.location.search).get("lang")</tt>.</center></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
        </div>
    

    

    

    
    
    

     

    

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id=".fill"><span class="type-signature type-signature-static">(static) </span>fill<span class="signature">(dictionary)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Fills the HTML strings defined by slugs.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>dictionary</code></td>
            

            <td class="type">
            
                
<span class="param-type">map.&lt;string, string></span>



            
            </td>

            

            

            <td class="description last"><p>The <code>{ &quot;slug&quot; : &quot;string&quot;, ... }</code> mapping.</p></td>
        </tr>

    
    </tbody>
</table>



















        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>